# std::unique_ptr< _Tp, _Tp_Deleter > Class Template Reference
[Pointer Abstractions]

20.7.12.2 unique_ptr for single objects. More...

List of all members.

## Public Types

- typedef _Tp_Deleter deleter_type
- typedef _Tp element_type
- typedef _Tp * pointer

## Public Member Functions

- unique_ptr (pointer __p)
- unique_ptr (pointer __p, typename std::remove_reference< deleter_type >::type &&__d)
- unique_ptr (unique_ptr &&__u)
- unique_ptr (const unique_ptr &)
- unique_ptr (pointer __p, typename std::conditional< std::is_reference< deleter_type >::value, deleter_type, const deleter_type & >::type __d)
- template<typename _Up , typename _Up_Deleter > unique_ptr (unique_ptr< _Up, _Up_Deleter > &&__u)
- pointer get () const
- const deleter_type & get_deleter () const
- deleter_type & get_deleter ()
- operator bool () const
- std::add_lvalue_reference
  < element_type >::type operator* () const
- pointer operator-> () const
- unique_ptr & operator= (const unique_ptr &)
- unique_ptr & operator= (unique_ptr &&__u)
- unique_ptr & operator= (__unspecified_pointer_type)
- template<typename _Up , typename _Up_Deleter > unique_ptr & operator= (unique_ptr< _Up, _Up_Deleter > &&__u)
- pointer release ()
- void reset (pointer __p=pointer())
- void swap (unique_ptr &__u)

## Detailed Description

### template<typename _Tp, typename _Tp_Deleter = default_delete<_Tp>>
class std::unique_ptr< _Tp, _Tp_Deleter >

20.7.12.2 unique_ptr for single objects.

Definition at line 81 of file unique_ptr.h.

The documentation for this class was generated from the following file:

- unique_ptr.h